<?php
	class ezFunctions {
		/* Elemente eines Ordners in einem Array speichern */
		public function get_objects_in_folder($path, $mode = 'all', $rekursive = true) {
			/*	(array) get_objects_in_folder( (string) $path [,(string) $mode[, (boolean) $rekursive]] )
				$path = Verzeichnispfad relativ zum aufrufenden Script
				$mode = Verzeichnisse und/oder Dateien? ('all', 'folder', 'files')
				$rekursive = Unterfolder mit auflisten? (true, false) */
			$path = preg_replace('~(.*)/$~', '\\1', $path); /* letzten Slash aus dem String entfernen */
			$list = array();
			$read = opendir($path);
			while($item = readdir($read)) {
				switch($mode) {
					case 'files':
					if (is_file("$path/$item"))
					$list[] = $rekursive ? "$path/$item" : $item;
					break;

					case 'folder':
					if (is_dir("$path/$item") && !preg_match('~^\.\.?$~', $item))
					$list[] = $rekursive ? "$path/$item" : $item;
					break;

					default:
					if (!preg_match('~^\.\.?$~', $item))
					$list[] = $rekursive ? "$path/$item" : $item;
				}
				/* Unterfolder? */
				if(!preg_match('~^\.\.?$~', $item) && is_dir("$path/$item") && $rekursive) {
					$list2 = $this->get_objects_in_folder("$path/$item", $mode, $rekursive);
					foreach($list2 as $item2) $list[] = $item2;
				}
			}
			closedir($read);
			sort($list);
			return $list;
		}
		
		
		/* berprft ob eine Variable gesetzt und mit Inhalt gefllt ist */
		public function is_arrayvalue_empty($key, $array) {
			if(array_key_exists($key, $array))  {
				if (empty($array[$key]) OR $array[$key] == " ") {
					return true;
				} else {
					return false;
				}
			} else {
				return true;
			}
		}
		
		
		/* Konvertiert die Statsdaten um fr die Verwendung auf der HP */
		public function convert_stats_data($data, $mode) {
			switch ($mode) {
				/* Allgemeine Funktionen */
				case "number":
					if (isset($data[3]) AND $data[3]) $title = $data[3]; else $title = "";
					if (isset($data[2]) AND $data[2]) $suffix = $data[2]; else $suffix = "";
					if (isset($data[1]) AND $data[1]) $decimal = $data[1]; else $decimal = 0;
					if ($data[0]) {
						$value = $data[0];
						
						if ($suffix == "k") {
							$form_value = number_format($value/1000, $decimal, ".", " ");
							$title_value = number_format($value, $decimal, ".", " ");
							if ($title != "") $title = $title.': '.$title_value;
						} elseif ($suffix == "%") {
							$form_value = number_format($value*100, $decimal, ".", " ");
							if ($title != "") $title = $title.': '.$form_value;
						} else {
							$form_value = number_format($value, $decimal, ".", " ");
							if ($title != "") $title = $title.': '.$form_value;
						}
						
					} else {
						$value = 0;
						$form_value = 0;
					}
					
					$value = str_pad($value, 10, "0", STR_PAD_LEFT);
					
					$result  = '<span class="hidden">'.$value.'</span>';
					$result .= '<span title="'.$title.'">'.$form_value.$suffix.'</span>';
					break;
				
				case "time":
					if (isset($data[3]) AND $data[3]) $title = $data[3]; else $title = "";
					if (isset($data[2]) AND $data[2]) $suffix = $data[2]; else $suffix = "";
					if (isset($data[1]) AND $data[1]) $decimal = $data[1]; else $decimal = 0;
					if ($data[0]) {
						$value = $data[0];
						
						$time = Array();
						$time['sec'] = $value % 60;
						$time['min'] = (($value - $time['sec']) / 60) % 60;
						$time['std'] = (((($value - $time['sec']) /60) - $time['min']) / 60) % 24;
						$time['day'] = floor( ((((($value - $time['sec']) /60) - $time['min']) / 60) / 24) ); 
						$time_string = sprintf('%dd %sh %sm', $time['day'],str_pad($time['std'], 2, "0", STR_PAD_LEFT), str_pad($time['min'], 2, "0", STR_PAD_LEFT));
						
						if ($suffix == "h") 	$form_value = number_format(round($value/3600), $decimal, ".", " ");
						if ($suffix == "min") 	$form_value = number_format(round($value/60), $decimal, ".", " ");
						if ($suffix == "date") {
							$form_value = $time_string;
							$suffix = "";
						}
					} else {
						$value = 0;
						$form_value = 0;
						$time_string = "0 min";
					}
					
					if ($title != "") 		$title = $title.': '.$time_string; else $title = "";
					
					$result  = '<span class="hidden">'.$value.'</span>';
					$result .= '<span title="'.$title.'">'.$form_value.$suffix.'</span>';
					break;
				
				case "ratio":
					if (isset($data[5]) AND $data[5]) $color = $data[5]; else $color = false;
					if (isset($data[4]) AND $data[4]) $title = $data[4]; else $title = "";
					if (isset($data[3]) AND $data[3]) $suffix = $data[3]; else $suffix = "";
					if (isset($data[2]) AND $data[2]) $decimal = $data[2]; else $decimal = 0;
					if ($data[0] AND $data[1]) {
						$value = $data[0] / $data[1];
						$form_value = number_format($value, $decimal, ".", " ");
						if ($color) {
							if ($value > 1) $class = "pos"; else $class = "neg";
						} else $class = "";
						
						if ($suffix == "%") 	$form_value = number_format($value*100, $decimal, ".", " ");
					} else {
						$value = 0;
						$form_value = 0;
						$class = "";
					}
					
					if ($title != "") 		$title = $title.': '.$form_value.$suffix; else $title = "";
					
					$result  = '<span class="hidden">'.$value.'</span>';
					$result .= '<span title="'.$title.'" class="'.$class.'">'.$form_value.$suffix.'</span>';
					break;
				
				/* Besondere Funktionen */
				case "rankicon":
					$ranknr = $data[0];
					$rankname = $data[1]["ranknames"][$ranknr];
					$iconsize = $data[1]["iconsize"];
					$relpath = $data[1]["relpath"];
					$image = $relpath.'stylesheets/images/ranks_'.$iconsize.'.png';
					$position = ($ranknr * $iconsize) - $iconsize;
					
					$result  = '<span class="hidden">'.str_pad($ranknr, 3, "0", STR_PAD_LEFT).'</span>';
					$result .= '<div class="rank" title="'.$rankname.' ('.$ranknr.')" style="width: '.$iconsize.'px; height: '.$iconsize.'px; background: url(\''.$image.'\') no-repeat scroll 0 -'.$position.'px transparent"></div>';
					break;
				
				case "stars":
					$stars = $data[0];
					$loc = $data[1];
					
					if (isset($stars['plat'])) {
						if ($stars['plat']) { 
							$icon = 0;
							$title = $stars['plat'].'x '.$loc['plat'];
						}
						elseif ($stars['gold']) { 
							$icon = 1; 
							$title = $stars['gold'].'x '.$loc['gold'];
						}
						elseif ($stars['silv']) { 
							$icon = 2;
							$title = $stars['silv'].'x '.$loc['silv'];
						}
						elseif ($stars['bron']) { 
							$icon = 3;
							$title = $stars['bron'].'x '.$loc['bron'];
						}
						else { 
							$icon = 4;
							$title = $stars['bron'].'x '.$loc['bron'];
						}
						
						$result  = '<span class="hidden">'.array_sum($stars).'</span>';
						$result .= '<span title="'.$title.'" class="stars" style="background-position: 0 -'.($icon * 24).'px"></span>';
					} else {
						$result = "";
					}
					
					break;
				
				case "namelink":
					$name = $data[0];
					$id = $data[1];
					$ezstats = $data[2];
					$title = $data[3];
					$rank = $data[4];
					$system = $data[5];
					
					if (isset($ezstats['playernames'][$id]) AND $ezstats['playernames'][$id] != "") $playername = $ezstats['playernames'][$id]; else $playername = $name;
					if (isset($ezstats['clantag'])) $playername = $ezstats['clantag'].$playername;
					
					if ($ezstats['detaillink']) {
						$url     = $ezstats['relpath'].'detail.php#'.$id;
						$result  = '<span class="hidden">'.htmlentities($playername).'</span>';
						$result .= '<a rel="ezDetail" href="'.$url.'" alt="'.$rank.' '.htmlentities($playername).'" title="'.$title.'">'.htmlentities($playername).'</a>';
						break;
					} else {
						$result  = '<span class="hidden">'.htmlentities($playername).'</span>';
						$result .= '<a href="http://bfbcs.com/stats_'.$system.'/'.urlencode($name).'" title="'.$title.'">'.htmlentities($playername).'</a>';
						break;
					}
				
				case "descriptions":
					$name = $data[0][$data[1]][0];
					$img = $data[0][$data[1]][1];
					$desc = $data[0][$data[1]][2];
					$text = $data[0][$data[1]][3];
					$type = $data[2];
					$relpath = $data[3];
					
					$title  = "[fieldset]";
					$title .= "[legend]".$name."[/legend]";
					$title .= "[dl]";
					$title .= "[dd][img src='".$relpath."stylesheets/images/".$type."/".$img."' /][/dd]";
					$title .= "[dd]".$desc."[/dd]";
					if ($text) $title .= "[dt]".$text."[/dt]";
					$title .= "[/dl]";
					$title .= "[/fieldset]";
					
					$result  = '<span class="hidden">'.$name.'</span>';
					$result .= '<span title="'.$title.'">'.$name.'</span>';
					
					break;
				
				case "dogtags":
					$stats = $data[0];
					$title = $data[1];
					
					$title = str_replace('%dogt_total%', $stats['dogt_total'], $title);
					$title = str_replace('%dogt_uniuque%', $stats['dogt_uniuque'], $title);
					$title = str_replace('%dogt_bron%', $stats['dogt_bron'], $title);
					$title = str_replace('%dogt_silv%', $stats['dogt_silv'], $title);
					$title = str_replace('%dogt_gold%', $stats['dogt_gold'], $title);
					$title = str_replace('%dogt_bron_u%', $stats['dogt_bron_u'], $title);
					$title = str_replace('%dogt_silv_u%', $stats['dogt_silv_u'], $title);
					$title = str_replace('%dogt_gold_u%', $stats['dogt_gold_u'], $title);
					
					$result  = '<span class="hidden">'.$stats['dogt_total'].'</span>';
					$result .= '<span title="'.$title.'">'.$stats['dogt_total'].'</span>';
					
					break;
				
				case "type":
					$rubric = $data[0];
					$type = $data[1];
					$title = $data[2];
					
					$order = Array(
						'vehicles' => Array(
							'heavy' => 4,
							'light' => 3,
							'air' => 2,
							'water' => 1,
							'stationary' => 0
						),
						'gadgets' => Array(
							'assault' => 4,
							'demo' => 3,
							'medic' => 2,
							'recon' => 1,
							'all' => 0
						)
					);
					
					$result  = '<span class="hidden">'.$order[$rubric][$type].'</span>';
					$result .= '<span title="'.$title['title_class'].': '.$title[$type].'">&diams;</span>';
					
					break;
				
				case "specials":
					$stats = $data[0];
					$loc = $data[1];
					$types = Array('resupplies', 'heals', 'revives');
					$result = "";
					
					foreach ($types as $type) {
						if (isset($stats[$type])) {
							$result  = '<span class="hidden">'.str_pad($stats[$type], 10, "0", STR_PAD_LEFT).'</span>';
							$result .= '<span title="'.$loc[$type].': '.$stats[$type].'">'.$stats[$type].'</span>';
						}
					}
					
					break;
				
				case "last_update":
					$date = substr($data[0], 0, 10);
					$time = substr($data[0], 11, 5);
					$result = $date.' '.$time;
					break;
			}
			
			return $result;
		}
		
		
		/* berprft ob eine neuere ezStats-Version verfgbar ist */
		public function check_version($version) {
			$ch = curl_init("http://www.ezzemm.de/pages/ezstats/curl.php?version");
			curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
			$check = curl_exec($ch);
			curl_close($ch);
			if ($check <= $version) {
				return false;
			} else {
				return true;
			}
		}
		
		
		/* CMS-Handbuch-Klasse */
		public function list_available_cms($active, $src) {
			$foldernames = $this->get_objects_in_folder($src, 'folder', false);
			$manuals = $this->get_objects_in_folder($src, 'folder', true);
			$result = "";
			
			for ($i = 0; $i < count($manuals); $i++) {
				$name = file_get_contents($manuals[$i].'/name.txt');
				if ($foldernames[$i] == $active) {
					$result .= '<dd><input type="radio" name="cms" value="'.$foldernames[$i].'" checked />'.$name.'</dd>';
				} else  {
					$result .= '<dd><input type="radio" name="cms" value="'.$foldernames[$i].'" />'.$name.'</dd>';
				}
			}
			return $result;
		}
		
		
		/* bersetzt die fr AJAX maskierten Steuerzeichen */
		public function replace_masked_control_characters($string) {
			$string = str_replace("*PLUS*", "+", $string);
			$string = str_replace("*EQUALS*", "=", $string);
			$string = str_replace("*AMPERSAND*", "&", $string);
			
			return $string;
		}
	}
?>